{ lib, config, ... }:

let
  cfg = config.crans;

  inherit (lib) mkEnableOption mkIf;
in
{
  imports = [
    ./age.nix
    ./home.nix
    ./locale.nix
    ./networking.nix
    ./ntp.nix
    ./restic_client.nix
    ./monitoring.nix
    ./nullmailer.nix
    ./packages.nix
    ./ssh.nix
    ./users.nix
    ./virtualisation.nix
  ];

  options.crans = {
    enable = mkEnableOption "Configuration commune à toutes les machines du Crans";
  };

  config = mkIf cfg.enable {
    crans = {
      homeNounou.enable = lib.mkDefault true;
      monitoring.enable = true;
      networking = {
        enable = true;
        adm.enable = lib.mkDefault true;
      };
      resticClient.enable = lib.mkDefault true;
      users = {
        ldap.enable = true;
      };
    };
  };
}
